/*
 * Bei diesem Programm handelt es sich um eine mögliche Lösung für Aufgabe 4 in Arbeitsblatt 13.
 * Die Steuerung besteht aus den folgenden Phasen:
 * 1. Motor des Manipulators dreht sich und bewegt so den ausgeschalteten E-Magneten nach unten.
 * 2. Der E-Magnet wird eingeschaltet. Der Motor ist in dieser Phase entweder kurz ausgeschaltet 
 * oder er bewegt sich langsam weiter. Beides ist möglich, da das Einschalten des Magnets sehr schnell geht.
 * 3. Der Motor dreht sich weiter und hebt den eingeschalteten Magneten mit der Last an.
 * 4.1. Der Motor dreht sich solange weiter, bis der Magnet wieder unten ist und dort ausgeschaltet wird.
 * 4.2. Am höchsten Punkt wird der Magnet ausgeschaltet und die Last fällt herunter (weniger effektiv, dafür sehr effektreich).
 * 
 * Benötigt wird neben dem Roboterarm jeweils ein Relais, über das der Laststrom für den Motor und den Magneten 
 * geschaltet werden kann - die Ansteuerung eines Relais (das hier verwendete schaltet bei HIGH) wird vorausgesetzt.
 * Benötigt werden daher ein Pin (Motor_out) für die Ansteuerung des Motorrelais, ein Pin (Magnet_out) für die 
 * Ansteuerung des Magnetrelais und zusätzlich, wenn auch nicht zwingend notwendig, ein Pin für die Inbetriebnahme (Ein_Aus).
 */


const int Motor_out = 2;
const int Magnet_out = 3;
const int Ein_Aus = 4;

void setup() 
{
  
/*
 * Die Pins für die Relais sind OUTPUT-Pins, während der Pin für den Schalter ein INPUT ist.
 */

 
pinMode (Motor_out, OUTPUT);
pinMode (Magnet_out, OUTPUT);
pinMode (Ein_Aus, INPUT);

}

void loop() {

/*
 * Die oben beschriebenen Aktionen müssen nun noch an die Bedingung geknüpft werden, dass der PIN 4 (Ein_Aus) HIGH ist.
 */

if (digitalRead(Ein_Aus) == HIGH) // wenn der Ein_Aus HIGH ist, dann soll das, was in den geschweiften Klammern folgt, passieren.
{
  digitalWrite (Motor_out, HIGH); // zunächst soll Motor_out HIGH gesetzt werden und damit das Motorrelais schalten.
  delay (15000); // delay verzögert das Weiterarbeiten des Programms um 15000 Millisekunden (hier die Zeit, bis der Arm unten ist).
  digitalWrite (Motor_out, LOW); // Hier wird die Version gewählt, bei der der Motor ausgeschaltet wird, bis der Magnet angeschaltet ist.

  digitalWrite (Magnet_out, HIGH); // Der Magnet wird eingeschaltet.
  digitalWrite (Motor_out, HIGH); // Der Motor wird wieder eingeschaltet.
  delay (15000); // Zeit, die benötigt wird, um den Arm wieder nach oben zu bewegen (Alternativ: delay(30000) um die Last wieder abzusetzen).
  digitalWrite (Motor_out, LOW); // Der Motor wird wieder ausgeschaltet.
  digitalWrite (Magnet_out, LOW); // Der Magnet wird ausgeschaltet, was dazu führt, dass die Last abfällt.
}
else // Wenn der Schalter nicht eingeschaltet ist, dann mache das, was in den folgenden geschweiften Klammern steht.
{
  digitalWrite (Motor_out, LOW); // Schalte den Motor aus.
  digitalWrite (Magnet_out, LOW); // Schalte den Magneten aus.
}

}

/*
 * Differenzierungsmöglichkeit: "Wie muss das Programm verändert werden, damit beim Ausschalten des Motors eine Last nicht herunterfällt, 
 * sondern gehalten wird, bis der Arm wieder eingeschaltet wird?"
 */

